Robotsystem from Robot Group Leipzig: OSGPrimitive Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# OSGPrimitive Class Reference

`#include <osgprimitive.h>`

Inheritance diagram for OSGPrimitive:

[legend]
List of all members.

## Detailed Description

Interface class for graphic primitives like spheres, boxes, and meshes, which can be drawn by OSG.

The idea is to hide all the details of the OSG implementation.

Definition at line 79 of file osgprimitive.h.

## Public Types
enum | Quality { Low, Middle, High }
## Public Member Functions
| OSGPrimitive ()
virtual | ~OSGPrimitive ()
virtual void | init (const OsgHandle &osgHandle, Quality quality=Middle)=0
| Initialisation of the primitive.
virtual void | setMatrix (const osg::Matrix &m4x4)
| Sets the transformation matrix of this object (position and orientation).
virtual osg::Group * | getGroup ()
| returns the group object which is the root of all subcomponents of this primitive
virtual void | setTexture (const std::string &filename)
| assigns a texture to the primitive
virtual void | setColor (const Color &color)
| sets the color for painting this primitive
virtual osg::Transform * | getTransform ()
| returns a osg transformation object;
## Protected Attributes
osg::ref_ptr< osg::Geode > | geode
osg::ref_ptr< osg::MatrixTransform > | transform
osg::ref_ptr< osg::ShapeDrawable > | shape

## Member Enumeration Documentation

enum Quality

  | Enumerator:
  Low |
  Middle |
  High |
Definition at line 82 of file osgprimitive.h.

## Constructor & Destructor Documentation

OSGPrimitive | ( |  | ) |

| Definition at line 98 of file osgprimitive.cpp.

~OSGPrimitive | ( |  | ) | `[virtual]`

| Definition at line 100 of file osgprimitive.cpp.

## Member Function Documentation

Group * getGroup | ( |  | ) | `[virtual]`

| returns the group object which is the root of all subcomponents of this primitive Reimplemented in OSGDummy. Definition at line 114 of file osgprimitive.cpp.

Transform * getTransform | ( |  | ) | `[virtual]`

| returns a osg transformation object; Reimplemented in OSGDummy. Definition at line 118 of file osgprimitive.cpp.

virtual void init | ( | const OsgHandle & | osgHandle,
|  | Quality | quality = `Middle`
| ) | `[pure virtual]`

| Initialisation of the primitive. Must in order to place the object into the scene. This function should be overloaded

void setColor | ( | const Color & | color | ) | `[virtual]`

| sets the color for painting this primitive Reimplemented in OSGDummy. Definition at line 131 of file osgprimitive.cpp.

virtual void setMatrix | ( | const osg::Matrix & | m4x4 | ) | `[virtual]`

| Sets the transformation matrix of this object (position and orientation). Reimplemented in OSGDummy.

void setTexture | ( | const std::string & | filename | ) | `[virtual]`

| assigns a texture to the primitive Reimplemented in OSGDummy. Definition at line 122 of file osgprimitive.cpp.

## Member Data Documentation

osg::ref_ptr<osg::Geode> geode`[protected]`

| Definition at line 101 of file osgprimitive.h.

osg::ref_ptr<osg::ShapeDrawable> shape`[protected]`

| Definition at line 103 of file osgprimitive.h.

osg::ref_ptr<osg::MatrixTransform> transform`[protected]`

| Definition at line 102 of file osgprimitive.h.